/*
 * vi:ts=4:sw=4
 * $Id: archive_ex.h,v 1.1 2001/11/29 13:06:26 kgt Exp $
 */
/*
 * archive_ex.h - Archive library extention for "Angel Ladder for MGL2"
 * Copyright (c) 2001 Hiroshi Kuwagata <kgt@topaz.ocn.ne.jp>
 * All rights reserverd.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by Hiroshi Kuwagata.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef __ARCHIVE_EX_H__
#define __ARCHIVE_EX_H__

#include "aladder.h"
#include "compress_lz77.h"

#define ARC_BMP_ITEMSZ	60
#define ARC_SCN_ITEMSZ	44
#define ARC_MAX_ITEMSZ	((ARC_BMP_ITEMSZ > ARC_SCN_ITEMSZ)? \
									ARC_BMP_ITEMSZ: ARC_SCN_ITEMSZ)

typedef struct _ArchiveExItem {
	char name[FNAME_LEN];
	int	width;
	int	height;
	int	osize;
	int	esize;
    struct _ArchiveExItem* next;
} ArchiveExItem;

typedef struct {
	char name[FNAME_LEN];
	FILE *fp;

	int type;

	int	num;
	ArchiveExItem* item;
	ArchiveExItem* last;
} ArchiveEx;

ArchiveEx* make_archive( int type, u_char* name);
void append_item( ArchiveEx* arc, u_char* name,
					void* data, int size, int width, int height);

#endif /* __ARCHIVE_EX_H__ */
