/*
 * vi:ts=4:sw=4:
 * $Id: hsb_color.h,v 1.1 2001/11/29 13:06:26 kgt Exp $
 */
/*
 * hsb_color.h
 * Copyright (C) 2001
 *      Hiroshi Kuwagata (kgt@topaz.ocn.ne.jp)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY HIROSHI KUWAGATA ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE TERRENCE R. LAMBERT BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
#ifndef __HSB_COLOR_H__
#define __HSB_COLOR_H__
#include <stdio.h>
#include <stdlib.h>

#define DITHER_NONE			0x00000000
#define DITHER_HUE			0x00000001
#define DITHER_SATUATION	0x00000002
#define DITHER_BRIGHTNESS	0x00000004
#define DITHER_ALL			(DITHER_HUE|DITHER_SATUATION|DITHER_BRIGHTNESS)
#define DITHER_FS			0x00000010
#define DITHER_JN			0x00000020
#define DITHER_MASK			0x000000ff

#define CHANGE_GRAYSCALE	0x00000100
#define DEPTH_2BPP			0x00000200
#define DEPTH_MASK			0x00000f00

#define WIDTH_PERCENT		0x00001000
#define WIDTH_DOT			0x00002000
#define WIDTH_MASK			0x00003000

#define HEIGHT_PERCENT		0x00004000
#define HEIGHT_DOT			0x00008000
#define HEIGHT_MASK			0x0000c000

#define WITH_ALPHA			0x00100000	// ޥ

#define MGL_DITHER_BIT		0x00004000
#define MGL_TRANSPARENT		0x00002000

typedef struct {
	int		r;
	int		g;
	int		b;
	int		t;
	int		a;
	int		c;
} COLOR_RGB;

typedef struct {
	int		h;
	int		s;
	int		b;
	int		a;
	int		t;
} COLOR_HSB;

extern int* mk_mgl_image( COLOR_RGB* s,
		 int w, int h, int f, int bri, int *dw, int *dh);

#endif /* __HSB_COLOR_H__ */
