/* 
 * Tenshi no Hashigo for X
 * Copyright (c) 2001 TAJIRI Yasuhiro <tajiri@venus.dti.ne.jp>
 * Original X11/xgui.c
 *  Copyright (c) 2001 TF <tf@denpa.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: sdlgui.c,v 1.5 2002/03/03 15:37:01 tf Exp $
 */
#include <SDL.h>
#include <signal.h>
#include <getopt.h>

#include "../aladder.h"
#include "sdlladder.h"

#include "SDLCore.h"

typedef int Bool;

static void window_init(void) ;

static SDLData sdldata;


typedef struct {
    Bool screen_mode;
} OptionValue;

 static struct option long_options[] =
{
        {"screen",    no_argument,       0,0 },
        {0, 0, 0, 0}
};

static OptionValue option_value;
/*
static void MenuPopup(Widget widget, XEvent *e, String *p, Cardinal *n);
static void quit_proc(Widget w, XEvent *e, String *p, Cardinal *n);
static void wm_quit_proc(Widget w, XEvent *e, String *p, Cardinal *n);
*/

static void
signal_handler(int sig)
{
}

static void *
setup_signal(int signo, void (*func)(int))
{

    struct sigaction act, oact;
    act.sa_handler = func;
    sigemptyset(&act.sa_mask);
    act.sa_flags = 0;
    if (sigaction(signo, &act, &oact) < 0)
	return SIG_ERR;
    return oact.sa_handler;
}

/*static void
RestrictWindowSize(Widget w)
{
    XSizeHints sh;

    sh.flags = PMinSize | PMaxSize;
    sh.min_width = WIDTH;
    sh.min_height = HEIGHT;
    sh.max_width = WIDTH;
    sh.max_height = HEIGHT;
    XSetWMNormalHints(XtDisplay(w), XtWindow(w), &sh);
}
*/
void
InitSDL(int argc, char *argv[])
{
//    setup_signal(SIGINT, signal_handler);
//    setup_signal(SIGTERM, signal_handler);

    window_init();
    SDLCoreBindRequestTable();
    alCore.DependData = (void *) &sdldata;
    InitFont(sdldata.display, SDL_FONT, 24);
    
}

void
DeleteSDL()
{
    SDL_FreeSurface(sdldata.display);
    SDLImageDestroy(sdldata.image);
    SDL_Quit();
}

static void
window_init() {
	char s[256];
#define sdl_vinfo sdldata.vf    
	SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO);
	SDL_WM_SetCaption(APP_NAME, APP_NAME);
	sdl_vinfo = SDL_GetVideoInfo();
	SDL_VideoDriverName(s, 256);
	sdldata.vflag = SDL_HWSURFACE | SDL_ANYFORMAT;
	sdldata.display = SDL_SetVideoMode(WIDTH, HEIGHT,
				       sdl_vinfo->vfmt->BitsPerPixel, sdldata.vflag);
	dprintf((stderr, "Dsp_depth %d flag %x\n",
	       sdldata.display->format->BitsPerPixel, sdldata.display->flags));
	sdldata.image = SDLImageCreate(sdldata.display,WIDTH,HEIGHT);
#undef sdl_vinfo    
}




