/* 
 * Tenshi no Hashigo for X
 * Copyright (c) 2001, 2002 TF <tf@denpa.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: aladder.h,v 1.75 2002/03/09 17:41:59 tf Exp $
 */
#ifndef __INCLUDE_ALADDER_H
#define __INCLUDE_ALADDER_H

#define APP_NAME "Angel Ladder"

#ifdef MAIN
#define EXTERN
#else
#define EXTERN extern
#endif

#ifndef True
#define True 1
#endif

#ifndef False
#define False 0
#endif

/* 
 * ܤԤ (20fps )
 */
#define WAIT_TIME 50000

/* 
 * २󥸥Υ⡼
 */
#define ENGINE_GAME 0
#define ENGINE_PREV 1
#define ENGINE_JINGLE 2
#define ENGINE_OPENING 3

/* 
 * ֽ
 */
#define ARC_SCN 0
#define ARC_BMP 1
#define ARC_WAV 2
#define ARC_ERR 3

#define FNAME_LEN 16

/* 
 * 
 */
#define ARG_LEN 64
#define ARG_NUM 7

#define FLAG_LEN 16

/* 
 * κĿ
 */
#define ALT_NUM 2

/* 
 * ץȽѥХåեΥ
 */
#define SCR_BUF_LEN 1024

/* 
 * եåط
 */
#define WIDTH 640
#define HEIGHT 480

#define FONT_WIDTH 32
#define FONT_HEIGHT 32
#define FONT_PADDING 6

#define CHARA_LEFT_MARGIN 32
#define CHARA_RIGHT_MARGIN 32

/* 
 * եȤΥ쥤Ȥ
 */
#define F_TOP 62
#define F_MAR 50
#define F_SPC 11
#define F_HEIGHT 70

/* 
 * ƥɽط
 */
#define TEXT_WIDTH 36
#define TEXT_HEIGHT 16

#define TEXT_WINDOW_POS 13

#define TEXT_WINDOW_TOP 352
#define TEXT_WINDOW_BORDER_TOP 336

#define BACKLOG_LEN 48

#define ATTR_NORMAL_MASK 0
#define ATTR_DICT_MASK (1 << 14)
#define ATTR_ALTN_MASK (1 << 15)
#define ATTR_LOG_MASK (1 << 16)
#define ATTR_ALL_MASK 0x0000ffff

#define ATTR_NORMAL 0
#define ATTR_LINK 1
#define ATTR_ALTN 2
#define ATTR_LINK_HL 3
#define ATTR_ALTN_HL 4
#define ATTR_BACKLOG 5

/* 
 * vram 
 */
#define WCHAR_SPACE 0xa1a1

/* 
 * 
 */
#define STAT_STACK_LEN 16

#define STAT_EMPTY 0
#define STAT_TEXT 1
#define STAT_ALTN 2
#define STAT_COMMAND 3
#define STAT_WAIT 4
#define STAT_CG 5
#define STAT_MENU 6
#define STAT_DIALOG 7
#define STAT_DICT 8
#define STAT_BACKLOG 9
#define STAT_WAIT_TIME 10

/* 
 * ξ
 */
#define STAT_TTL_TITLE_FADE 11
#define STAT_TTL_TITLE_ENTRY 12
#define STAT_TTL_MENU_FLY 13
#define STAT_TTL_TITLE 14
#define STAT_TTL_GAME 15
#define STAT_TTL_ROOM 16
#define STAT_TTL_CGMODE 17
#define STAT_TTL_CGVIEW 18
#define STAT_TTL_PREVMODE 19
#define STAT_TTL_MUSIC 20
#define STAT_TTL_CONFIG 21
#define STAT_TTL_TITLE_END 22

/* 
 * ץ˥󥰤ξ
 */
#define STAT_ANIM 23
#define STAT_ANIM_WAIT 24
#define STAT_ANIM_QUIT 25

/* 
 * 桼
 */
#define CONFIG_WINDOW 0
#define CONFIG_FULLSCREEN 1

#define CONFIG_TEXT_SLOW 0
#define CONFIG_TEXT_NORMAL 1
#define CONFIG_TEXT_FAST 2

/* 
 * ǥ쥯ȥ
 */
#ifndef AL_APP_DIR
#define AL_APP_DIR "/home/tf/work/angelladder"
#endif
#ifndef AL_MUSIC_DIR
#define AL_MUSIC_DIR "/home/tf/work/angelladder/Music"
#endif

/* 
 * άɽ
 */
#define DIR alCore.dir
#define TEXT alCore.text
#define WAIT alCore.wait
#define SCENE alCore.scene
#define CURSOR alCore.cursor
#define CONFIG alCore.config
#define SCRIPT alCore.script
#define HISTORY alCore.text_history
#define ALIB alCore.AngelLib
#define REQTBL alCore.RequestTable
#define CURRENT_STATE (alCore.state_stack[alCore.state_stack_depth])

#ifdef HAVE_IMAGE_CACHE
#define SET_CACHE(x,y) ALIB.imageLoad(x,y)
#else
#define SET_CACHE(x,y)
#endif

#ifdef DEBUG
#define dprintf(a) fprintf a
#else
#define dprintf(a)
#endif

#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <setjmp.h>

#include "image.h"

typedef struct {
    char name[FNAME_LEN];
    int pos;
    int width;
    int height;
    int osize;
    int esize;
} ArchiveItem;

typedef struct {
    FILE *fp;
    int num;
    int type;
    ArchiveItem *item;
} Archive;

typedef struct _SceneList {
    u_char name[ARG_LEN];
    int offset;
    struct _SceneList *next;
} SceneList;

typedef struct _FlagList {
    u_char value[FLAG_LEN];
    struct _FlagList *next;
} FlagList;

typedef enum {
    JUMP_NONE,
    JUMP_RESTART,
    JUMP_JINGLE,
    JUMP_OPENING,
    JUMP_TITLE,
    JUMP_ENDING,
    JUMP_END
} JumpParameter;

typedef struct {
    u_char name[ARG_LEN];	/* ߤΥ̾ */
    char bg[ARG_LEN];		/* طCG */
    char left[ARG_LEN];		/* Ω() */
    char middle[ARG_LEN];	/* Ω() */
    char right[ARG_LEN];	/* Ω() */
    char bgm[ARG_LEN];		/* BGM */
    int block_top;
    int pos;
    int offset;
} Scene;

typedef struct {
    struct {
	u_char *data;
	int cur_pos;
	int end_pos;
	SceneList *scene_list;
    } script;

    struct {
	char *save_dir;
	char *app_dir;
	char *music_dir;
    } dir;

    struct {
	int string[ARG_LEN];
	u_char label[ARG_LEN];
    } alternative[ALT_NUM];

    int alternative_num;
    int engine_mode;

    FlagList *flag;
    FlagList *cg_flag;
    FlagList *prev_flag;
    FlagList *read_flag;

    struct {
	int tvram[TEXT_WIDTH][TEXT_HEIGHT];
	int attr[TEXT_WIDTH][TEXT_HEIGHT];
	int geom[TEXT_WIDTH][TEXT_HEIGHT];
	int x;
	int y;
	int yoffset;
	int clear;
	int highlight;
	int fullscreen;
	int view_width;
    } text;

    struct {
	int x;
	int y;
	int move;
    } cursor;

    struct {
	int tvram[TEXT_WIDTH][BACKLOG_LEN];
	int y;
	int loop;
    } text_history;

    struct {
	int skip;		/* ޤ̤ɤʸϤޤФ */
	int drop_frame;		/* ե졼ȯ */
    } wait;

    struct {
	int window_size;
	int text_speed;
	int use_effect;
	int skip_read;		/* ɤʸϤФ */

	int skip_jingle;	/* 󥰥Ф */
	int skip_opening;	/* ץ˥󥰤Ф */
	int force_skip;		/* ƥȥåפ̤ɤʸϤФ */
    } config;

    Scene scene;

    int brightness;
    int state_stack_depth;
    int state_stack[STAT_STACK_LEN];

    Image *work;
    Image *sub;
    Image *vram;

    /* ٥ API */
    struct {
	Image *(*imageNew) (int width, int height);
	void (*imageDelete) (Image *image);
	void (*imageLoad) (Image *image, const char *name);
	void (*imageFill) (Image *image, int x, int y, int w, int h,
			   Color color);
	void (*imageAdd) (Image *dst, Image *src, int xoff, int yoff);
	Image *(*imageCreateMask) (Image *src);
	void (*imageCopy) (Image *dst, Image *src, int xd, int yd, int xs,
			   int ys, int w, int h);
	void (*imageAddWithMask) (Image *dst, Image *src, Image *mask,
				  int xoff, int yoff);
	void (*imageMerge) (Image *dst, Image *src1, Image *src2,
			    int alpha);
	void (*imageBox) (Image *image, int x, int y, int w, int h,
			  Color color);
	void (*imageHalfSize) (Image *dst, Image *src);
	void (*imageBlendPattern) (Image *dst, Image *src, int x, int y,
				   int step);
	void (*imageDarken) (Image *image, int brightness);
	void (*imageCharacterLoad) (Image *dst, char arg[][ARG_LEN],
				    int num);

	void (*imageDisplay) (int brightness);

	int (*putChar) (int code, int x, int y, int attr);
	void (*drawImageString) (u_int *str, int x, int y, Color col,
				 int alpha);
	int (*imageStringWidth) (u_int *str);
	void (*coordTextToGraphics) (int tx, int ty, int *gx, int *gy);
	void (*coordGraphicsToText) (int gx, int gy, int *tx, int *ty);

	int (*soundOpen) ();
	void (*soundClose) ();
	void (*soundLoad) (const char *name);
	void (*soundPlay) ();
	void (*soundStop) ();
	int (*soundStatus) ();

	int (*musicOpen) ();
	void (*musicClose) ();
	void (*musicLoad) (const char *name);
	void (*musicPlay) ();
	void (*musicStop) ();
	void (*musicFadeOut) ();
	int (*musicStatus) ();
    } AngelLib;

    /* ץåȥե¸Υǡ */
    void *DependData;

    /* ץåȥե¸ν */
    struct {
	void (*flushWindow) ();
	void (*flushWindowArea) (int x, int y, int w, int h);
	void (*clearWindow) ();
	 ALFont(*getFontGryph) (int code);
	void (*flip) ();
	void (*destroy) ();
	void (*setFullScreenMode) (int mode);
    } RequestTable;

    Archive *cg_arc;
    Archive *script_arc;
    Archive *sound_arc;

    jmp_buf jump;

} ALCore;

typedef struct {
    struct timeval start;
    long msec;
} timer;

EXTERN ALCore alCore;

u_char *get_text(Archive *arc, const char *name);
Archive *open_archive(char *filename);
void close_archive(Archive *arc);

/* main.c */
void LongJump(JumpParameter param);
void ClearScene();
void init_variable();

/* action.c */
void event_queue_init();
void event_queue_put(int in_data);
int event_queue_get();
int event_queue_is_empty();
void trap_area_clear();
void trap_area_add(int x, int y, int w, int h);
int trap_area_selected();

void action_motion();
void action_click_button1();
void action_click_button2();
void action_key_skip();
void action_key_cg();
void action_key_esc();
void action_key_up();
void action_key_down();

void Motion(int x, int y);
void ClickButton1();
void ClickButton2();
void KeySkip();
void KeyCG();
void CursorUp();
void CursorDown();

/* archive_image.c */
void get_image(Archive *arc, const char *name, Image *image);

/* archive_sound.c */
u_char *get_sound(Archive *arc, const char *name, int *size);

/* archive_text.c */
void load_script(const char *name);
void free_script();

/* backlog.c */
void backlog_init();
void backlog_enter();
void backlog_leave();
void backlog_up();
int backlog_down();

/* cursor.c */
void cursor_init();
void draw_cursor();
void clear_cursor();

/* flags.c */
void add_flag(const char *flag, FlagList **flist);
void clear_flag(FlagList **flist);
int isset_flag(FlagList *p, const char *query);

/* file.c */
void setup_directory();
void save_persistent_info();
void load_persistent_info();
void SaveGame(const char *name);
void LoadGame(const char *name);
void get_save_file_info(int num, u_char *date, u_char *desc);

/* image.c */
void ImageLibInit();

/* script.c */
void clear_stack();
void push_stack(int val);
int pop_stack();
int script_parse_arg(const char *cmd, char argv[ARG_NUM][ARG_LEN]);
void script_seen_proc();
void run_engine(int engine_mode);
int proc_menu();

/* command.c */
void set_command(const char *cmd);
int get_command_arg(char arg[ARG_NUM][ARG_LEN]);
int proc_command(int interrupt);

/* dictionary.c */
void dict_mode_leave();
void dict_init(const char *dictfile);
void dict_destory();
void dict_lookup(u_int *text, u_int *attr);
void dict_get_entry(int id, u_int *word, u_int *desc);
void dict_button_push();
void dict_button_release();

/* dict_lookup.c */
void push_dict();
void pop_dict();

/* effect.c */
int FadeIn();
int FadeOut();
int Lighten(int *state);
int Darken(int *state);
int EffectAlphaBlend(int *state);
int VerticalShake(int *state, int amp);
int RandomShake(int *state, int count);
int WipeParallelVLtoR(int *state);
int WipeParallelVRtoL(int *state);
int WipeParallelHBtoT(int *state);
int WipeParallelHTtoB(int *state);
int WipeLtoR(int *state, int flush);
int WipeRtoL(int *state, int flush);
int FadePattern(int *state, int flush);
#ifdef FAST_EFFECT
int FadePattern8(int *state, int flush);
int WipeLtoR2(int *state, int flush);
#endif

/* text.c */
int is_kinsoku_o(int next);
int is_kinsoku_c(int next);
void text_init();
void clear_text(int draw_window);
void redraw_text();
void push_text();
void pop_text();
void newpage();
int put_char(int c, int attr, int next);
int newline();
void set_text(const u_char *text);
int proc_text();
void clear_text_stack();
void clear_tvram();
void print_backlog(int from, int num);

/* menu.c */
void menu_set(const char *name);
int menu_action(const char *name, int selection);
void menu_draw_frame();
void menu_set_selected(int sel);
void menu_clear();

/* util.c */
void *setup_signal(int signo, void (*func) (int));
void *clear_signal(int signo);
void sjis2euc(char *sjis, char *euc);
int text_len(int *text);
void text_cpy(int *dst, int *src);
void euc_to_text(u_char *euc, int *text);
int text_cmp(int *text1, int *text2, int num);
void init_timer(timer *tp);
void get_timer(timer *tp);
Color string2color(const char *string);
void init_wait_timer(int second);
int end_wait_timer();

/* scene.c */
void ClearWorkScene();
void WorkSceneBg(const char *bg);
void WorkSceneOutBg(const char *bg);
void WorkSceneClearAllChara();
void WorkSceneClearChara(const char *name);
void WorkSceneChara(const char *pos, const char *cg);
Scene GetWorkScene();
void ReflectWorkScene();
void CopyScene();
void RedisplayScene(Image *image, Scene scene);
void BackupScene();
void RestoreScene();

/* jingle.c */
void run_jingle_engine();

/* opening.c */
void run_opening_engine();

/* ending.c */
void ending_set_id();
void run_ending_engine();

/* title.c */
void run_title_engine();

/* cg_mode.c */
void enter_cg_mode();
void leave_cg_mode();
void redraw_cg_mode();
void proc_cg_mode();
void forward_cg_mode();
void backward_cg_mode();
void enter_cg_view();
void leave_cg_view();
void forward_cg_view();

/* config_mode.c */
void enter_config_mode();
void leave_config_mode();
void redraw_config_mode();
int proc_config_mode();

/* music_mode.c */
void enter_music_mode();
void redraw_music_mode();

/* prev_mode.c */
void enter_prev_mode();
void leave_prev_mode();
void redraw_prev_mode();
void proc_prev_mode();
void forward_prev_mode();
void backward_prev_mode();

/* option.c */
void parse_argument(int argc, char *argv[], int *dargc_p,
		    char **dargv_p[]);
#endif
