.\" 
.\"  Tenshi no Hashigo for X
.\"  Copyright (c) 2001, 2002 TF <tf@denpa.org>
.\"  All rights reserved.
.\" 
.\"  Redistribution and use in source and binary forms, with or without
.\"  modification, are permitted provided that the following conditions
.\"  are met:
.\"  1. Redistributions of source code must retain the above copyright
.\"     notice, this list of conditions and the following disclaimer.
.\"  2. Redistributions in binary form must reproduce the above copyright
.\"     notice, this list of conditions and the following disclaimer in the
.\"     documentation and/or other materials provided with the distribution.
.\"  3. All advertising materials mentioning features or use of this software
.\"     must display the following acknowledgment:
.\"       This product includes software developed by TF.
.\"  4. The name of the author may not be used to endorse or promote products
.\"     derived from this software without specific prior written permission.
.\" 
.\"  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\"  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\"  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\"  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\"  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\"  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\"  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\"  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\"  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\"  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.TH angelladder 1 "3 Mar 2002"
.SH NAME
angelladder \- emulate `Tenshi no Hashigo' on UNIX platforms.
.SH SYNOPSIS
.B angelladder
[
.B \--skip-jingle
]
[
.B \--skip-opening
]
[
.B \--force-skip
]
[
.B \--fullscreen
]
.SH DESCRIPTION
.B angelladder
emulates `Tenshi no Hashigo', a game developed by the Studio Air for
Windows platforms, on UNIX platfoms.
.P
.B angelladder
has multiple frontends (Xt and SDL) and you can choose the best one
for your environment.
.P
To play
.BR angelladder ,
you require an original package of `Tenshi no Hashigo.'
.BR angelladder
reads scripts, images and voices from its archives.
.SH OPTIONS
.TP
.B --skip-jingle
Skip the logo animation on startup.
.TP
.B --skip-opening
Skip the opening animation on startup.
.TP
.B --force-skip
Make the `skip to unread sentence' command to ignore unread sentences.
Therefore, the skip command doesn't stop until an alternative selection.
.TP
.B --fullscreen
Switch to fullscreen mode on startup, if supported.
.SH COMMAND
.TP 8
.B Go to the next script
Mouse button 1, Enter key
.TP 8
.B Select an alternative
Mouse button1, Enter key
.TP 8
.B Popup the command menu
Mouse button 3, Escapekey
.TP 8
.B Hide text (Show a background graphics)
Space key
.TP 8
.B Skip to unread sentence
Alt + s
.TP 8
.B Rollback the text
Up/Down-Arrow, Mouse button 4, 5 (useful to bind them to a mouse wheel)
.TP 8
.B Quick save/load (only the Xt frontend)
Mouse button 2 pops-up the command menu.
.SH ENVIRONMENT
.TP 8
.B AL_APP_DIR
A directory to find BData_01.dat, EData_01.dat and VData_01.dat files.
.TP 8
.B AL_MUSIC_DIR
A directory to find mp3 files for BGM.
.SH FILES
.TP 8
.B <HOME>/.angelladder
A directory to store the save data.
.SH AUTHER
TF <tf@denpa.org>, wrote the base code and the Xt frontend.
.br
TAJIRI Yasuhiro <tajiri@venus.dti.ne.jp>, wrote the SDL frontend.

