/* 
 * Tenshi no Hashigo for X
 * Copyright (c) 2001 TF <tf@denpa.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: archive_sound.c,v 1.5 2002/03/03 15:37:00 tf Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "aladder.h"

u_char *
get_sound(Archive *arc, const char *name, int *size)
{
    int i;
    u_char *snd;

    if (arc->type != ARC_WAV) {
	fprintf(stderr, "̲֤ǤϤޤ(%s)\n", name);
	return NULL;
    }

    for (i = 0; i < arc->num; i++) {
	if (!strcasecmp(arc->item[i].name, name))
	    break;
    }
    if (i == arc->num) {
	fprintf(stderr, "̲Ĥޤ(%s)\n", name);
	return NULL;
    }

    if (arc->item[i].osize != arc->item[i].esize) {
	fprintf(stderr, "ͽʤƤǤ(%s)\n", name);
	return NULL;
    }

    snd = (u_char *) malloc(arc->item[i].esize);
    fseek(arc->fp, arc->item[i].pos, SEEK_SET);
    fread(snd, arc->item[i].esize, 1, arc->fp);

    *size = arc->item[i].esize;
    return snd;
}
