/* 
 * Tenshi no Hashigo for X
 * Copyright (c) 2002 TF <tf@denpa.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: cg_list.h,v 1.2 2002/03/03 15:37:00 tf Exp $
 */

#ifndef __INCLUDE_CG_LIST_H
#define __INCLUDE_CG_LIST_H

static struct {
    char *name;
    int id;
} cg_index[16][16] = {
  {
    {"tRCG001.bmp", 0}, 
    {"tRCG002.bmp", 1},
    {"tRCG003.bmp", 2},
    {"tRCG004_01.bmp", 3},
    {"tRCG004_02.bmp", 4},
    {"tRCG004_03.bmp", 5},
    {"tRCG004_04.bmp", 6},
    {"tRCG004_05.bmp", 7},
    {"tRCG004_06.bmp", 8},
    {"tRCG004_07.bmp", 9},
    {"tRCG005_01.bmp", 10},
    {"tRCG005_02.bmp", 11},
    {"tRCG005_03.bmp", 12},
    {"tRCG005_04.bmp", 13},
    {"tRCG006.bmp", 14},
    {"tRCG007.bmp", 15}
  },{
    {"tRCG008.bmp", 16},
    {"tRCG012_01.bmp", 17},
    {"tRCG012_02.bmp", 18},
    {"tRCG012_03.bmp", 19},
    {"tRCG013.bmp", 20},
    {"tRCG014.bmp", 21},
    {"tRCG015.bmp", 22},
    {"tRCG016_01.bmp", 23},
    {"tRCG016_02.bmp", 24},
    {"tRCG016_03.bmp", 25},
    {"tRCG016_04.bmp", 26},
    {"tRCG016_05.bmp", 27},
    {"tRCG017_01.bmp", 28},
    {"tRCG017_02.bmp", 29},
    {"tRCG017_03.bmp", 30},
    {"tRCG017_04.bmp", 31}
  }, {
    {"tRCG018_01.bmp", 32},
    {"tRCG018_02.bmp", 33},
    {"tRCG019_01.bmp", 34},
    {"tRCG019_02.bmp", 35},
    {"tRCG020_01.bmp", 36},
    {"tRCG020_02.bmp", 37},
    {"tRCG020_03.bmp", 38},
    {"tRCG020_04.bmp", 39},
    {"tRCG021.bmp", 40},
    {"tRCG022.bmp", 41},
    {"tRCG023_01.bmp", 42},
    {"tRCG023_02.bmp", 43},
    {"tRCG024.bmp", 44},
    {"tRCG025_01.bmp", 45},
    {"tRCG025_02.bmp", 46},
    {"tRCG026_01.bmp", 47}
  }, {
    {"tRCG026_02.bmp", 48},
    {"tRCG026_03.bmp", 49},
    {"tRCG026_04.bmp", 50},
    {"tRCG026_05.bmp", 51},
    /* "tRCG026_06.bmp", 0}, */
    {"tRCG027.bmp", 52},
    {"tRCG028.bmp", 53},
    {"tRCG029_01.bmp", 54},
    {"tRCG029_02.bmp", 55},
    {"tRCG029_03.bmp", 56},
    {"tRCG030.bmp", 57},
    {"tRCG031_01.bmp", 58},
    {"tRCG031_02.bmp", 59},
    {"tKCG001_01.bmp", 60},
    {"tKCG001_02.bmp", 61},
    {"tKCG002_01.bmp", 62},
    {"tKCG002_02.bmp", 63}
  }, {
    {"tKCG003.bmp", 64},
    {"tKCG005.bmp", 65},
    {"tKCG006.bmp", 66},
    {"tKCG007_01.bmp", 67},
    {"tKCG007_02.bmp", 68},
    {"tKCG007_03.bmp", 69},
    {"tKCG008_01.bmp", 70},
    {"tKCG008_02.bmp", 71},
    {"tKCG008_03.bmp", 72},
    {"tKCG009_01.bmp", 73},
    {"tKCG009_02.bmp", 74},
    {"tKCG009_03.bmp", 75},
    {"tKCG010_01.bmp", 76},
    {"tKCG010_02.bmp", 77},
    {"tKCG010_03.bmp", 78},
    {"tKCG011_01.bmp", 79}
  }, {
    {"tKCG011_02.bmp", 80},
    {"tKCG012_01.bmp", 81},
    {"tKCG012_02.bmp", 82},
    {"tKCG013.bmp", 83},
    {"tKCG014_01.bmp", 84},
    {"tKCG014_02.bmp", 85},
    {"tKCG015_01.bmp", 86},
    {"tKCG015_02.bmp", 87},
    {"tKCG015_03.bmp", 88},
    {"tKCG015_04.bmp", 89},
    {"tKCG016_01.bmp", 90},
    {"tKCG016_02.bmp", 91},
    {"tKCG016_03.bmp", 92},
    {"tKCG016_04.bmp", 93},
    {"tKCG017.bmp", 94},
    {"tKCG018.bmp", 95}
  }, {
    {"tKCG019.bmp", 96},
    {"tKCG020.bmp", 97},
    {"tKCG021.bmp", 98},
    {"tKCG022_01.bmp", 99},
    {"tKCG022_02.bmp", 100},
    {"tKCG023.bmp", 101},
    {"tKCG024.bmp", 102},
    {"tKCG025.bmp", 103},
    {"tKCG026_01.bmp", 104},
    {"tKCG026_02.bmp", 105},
    {"tKCG026_03.bmp", 106},
    {"tKCG027.bmp", 107},
    {"tKCG028.bmp", 108},
    {"tKCG029.bmp", 109},
    {"tKCG030.bmp", 110},
    {"tKCG031.bmp", 111}
  }, {
    {"tKCG032_01.bmp", 112},
    {"tKCG032_02.bmp", 113},
    {"tKCG033_01.bmp", 114},
    {"tKCG033_02.bmp", 115},
    {"tKCG033_03.bmp", 116},
    {"tKCG034.bmp", 117},
    {"tKCG035.bmp", 118},
    {"tKCG036.bmp", 119},
    {"tKCG037.bmp", 120},
    {"tKCG038.bmp", 121},
    {"tKCG039.bmp", 122},
    {"tKCG050.bmp", 123},
    {"tKCG051_01.bmp", 124},
    {"tKCG051_02.bmp", 125},
    {"tKCG051_03.bmp", 126},
    {"tKCG052.bmp", 127}
  }, {
    {"tKCG053.bmp", 128},
    {"tKCG054_01.bmp", 129},
    {"tKCG054_02.bmp", 130},
    {"tKCG054_03.bmp", 131},
    {"tKCG054_04.bmp", 132},
    {"tKCG054_05.bmp", 133},
    {"tKCG054_06.bmp", 134},
    {"tKCG055_01.bmp", 135},
    {"tKCG055_02.bmp", 136},
    {"tKCG055_03.bmp", 137},
    {"tKCG055_04.bmp", 138},
    {"tKCG057_01.bmp", 139},
    {"tKCG057_02.bmp", 140},
    {"tKCG057_03.bmp", 141},
    {"tKCG057_04.bmp", 142},
    {"tKCG058_01.bmp", 143}
  }, {
    {"tKCG058_02.bmp", 144},
    {"tKCG059_01.bmp", 145},
    {"tKCG059_02.bmp", 146},
    {"tKCG059_03.bmp", 147},
    {"tKCG060.bmp", 148},
    {"tKCG061_01.bmp", 149},
    {"tKCG061_02.bmp", 150},
    {"tKCG062_01.bmp", 151},
    {"tKCG062_02.bmp", 152},
    {"tKCG062_03.bmp", 153},
    {"tKCG063_01.bmp", 154},
    {"tKCG063_02.bmp", 155},
    {"tTCG001.bmp", 156},
    {"tTCG002_01.bmp", 157},
    {"tTCG002_02.bmp", 158},
    {"tTCG003_01.bmp", 159}
  }, {
    {"tTCG003_02.bmp", 160},
    {"tTCG004_01.bmp", 161},
    {"tTCG004_02.bmp", 162},
    {"tTCG005_01.bmp", 163},
    {"tTCG005_02.bmp", 164},
    {"tTCG006_01.bmp", 165},
    {"tTCG006_02.bmp", 166},
    {"tTCG006_03.bmp", 167},
    {"tTCG007.bmp", 168},
    {"tTCG008_01.bmp", 169},
    {"tTCG008_02.bmp", 170},
    {"tTCG009_01.bmp", 171},
    {"tTCG009_02.bmp", 172},
    {"tTCG009_03.bmp", 173},
    {"tTCG010_01.bmp", 174},
    {"tTCG010_02.bmp", 175}
  }, {
    {"tTCG010_03.bmp", 176},
    {"tTCG011_01.bmp", 177},
    {"tTCG011_02.bmp", 178},
    {"tTCG012_01.bmp", 179},
    {"tTCG012_02.bmp", 180},
    {"tTCG013_01.bmp", 181},
    {"tTCG013_02.bmp", 182},
    {"tTCG013_03.bmp", 183},
    {"tTCG013_04.bmp", 184},
    {"tTCG014.bmp", 185},
    {"tTCG015.bmp", 186},
    {"tTCG016_01.bmp", 187},
    {"tTCG016_02.bmp", 188},
    {"tTCG017.bmp", 189},
    {"tTCG018_01.bmp", 190},
    {"tTCG018_02.bmp", 191}
  }, {
    {"tTCG019.bmp", 192},
    {"tTCG020.bmp", 193},
    {"tTCG021.bmp", 194},
    {"tTCG022.bmp", 195},
    {"tTCG023.bmp", 196},
    {"tTCG024.bmp", 197},
    {"tTCG025.bmp", 198},
    {"tTCG026_01.bmp", 199},
    {"tTCG026_02.bmp", 200},
    {"tTCG026_03.bmp", 201},
    {"tTCG027.bmp", 202},
    {"tTCG028_01.bmp", 203},
    {"tTCG028_02.bmp", 204},
    /* {"tTCG028_03.bmp", 0}, */
    {"tTCG029.bmp", 205},
    {"tTCG030.bmp", 206},
    {"tTCG031.bmp", 207}
  }, {
    {"tMCG001_01.bmp", 208},
    {"tMCG001_02.bmp", 209},
    {"tMCG002_01.bmp", 210},
    {"tMCG002_02.bmp", 211},
    {"tMCG003.bmp", 212},
    {"tMCG004.bmp", 213},
    {"tMCG005_01.bmp", 214},
    {"tMCG005_02.bmp", 215},
    {"tMCG006.bmp", 216},
    {"tMCG007.bmp", 217},
    {"tMCG008_01.bmp", 218},
    {"tMCG008_02.bmp", 219},
    {"tMCG009.bmp", 220},
    {"tMCG010_01.bmp", 221},
    {"tMCG010_02.bmp", 222},
    {"tMCG011_01.bmp", 223}
  }, {
    {"tMCG011_02.bmp", 224},
    {"tMCG012.bmp", 225},
    {"tMCG013.bmp", 226},
    {"tMCG014.bmp", 227},
    {"tMCG015_01.bmp", 228},
    {"tMCG015_02.bmp", 229},
    {"tMCG015_03.bmp", 230},
    {"tMCG016_01.bmp", 231},
    {"tMCG016_02.bmp", 232},
    {"tMCG017.bmp", 233},
    {"tMCG018_01.bmp", 234},
    {"tMCG018_02.bmp", 235},
    {"tMCG019.bmp", 236},
    {"tMCG020_01.bmp", 237},
    {"tMCG020_02.bmp", 238},
    {"tSCG001.bmp", 239}
  }, {
    {"tSCG002.bmp", 240},
    {"tSCG003_01.bmp", 241},
    {"tSCG003_02.bmp", 242},
    {"tSCG004_01.bmp", 243},
    {"tSCG004_02.bmp", 244},
    {"tSCG005.bmp", 245},
    {"tSCG006.bmp", 246},
    {"tSCG007_01.bmp", 247},
    {"tSCG007_02.bmp", 248},
    {"tSCG008.bmp", 249},
    {"tKCG040.bmp", 250},
    {"t_no.bmp", -1},
    {"t_no.bmp", -1},
    {"t_no.bmp", -1},
    {"t_no.bmp", -1},
    {"t_no.bmp", -1},
  }
};
#endif
