/* 
 * Tenshi no Hashigo for X
 * Copyright (c) 2001, 2002 TF <tf@denpa.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: image.h,v 1.11 2002/03/09 17:41:59 tf Exp $
 */
#ifndef __INCLUDE_IMAGE_H
#define __INCLUDE_IMAGE_H

/* 
 * 쥤
 */
#define XOFFSET 24
#define YOFFSET 16

#define ABS_LEFT_MARGIN 36
#define LEFT_MARGIN 48
#define PRE_LEFT_MARGIN 80

#define DICT_YOFFSET 52
#define DICT_LEFT_MARGIN 90
#define DICT_ABS_LEFT_MARGIN 78
#define DICT_PRE_LEFT_MARGIN 102
#define DICT_SUBJECT_Y 10

#define XMAX 27
#define YMAX 16
#define XPAD 0
#define YPAD 3

typedef struct {
    char *name;
    void *bitmap;		/* ӥåȥޥå(ϥƥ¸) */
    int width;
    int height;
    void *dep_data;		/* ץåȥեͭΥǡ */
} Image;

typedef struct {
    u_char r;
    u_char g;
    u_char b;
    void *dep_data;		/* ץåȥեͭΥǡ */
} Color;

typedef struct {
    int pitch;
} FontInfo;

typedef struct {
    void *bitmap;
    int width;
} ALFont;

EXTERN FontInfo finfo;

EXTERN Color BLACK;
EXTERN Color WHITE;
EXTERN Color GRAY;
EXTERN Color YELLOW;
EXTERN Color PINK;

EXTERN u_char bri_map[21][256];
EXTERN u_char alpha_map[256][256][256];

void ImageLibInit();
int PutChar(int code, int x, int y, int attr);
void DrawImageString(u_int *str, int x, int y, Color color, int alpha);
int ImageStringWidth(u_int *str);

#ifdef FAST_EFFECT
void ImageBlendPattern8(Image *dst, Image *src, int x, int y, int step);
#endif

void cache_new();
void cache_delete();

#endif
