/* 
 * Tenshi no Hashigo for X
 * Copyright (c) 2002 TF <tf@denpa.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: music_mode.c,v 1.4 2002/03/03 15:37:00 tf Exp $
 */

#include "aladder.h"

static Image *back_r, *play_r, *stop_r;
static Image *back_p, *play_p, *stop_p;

static void
init_music_mode_widget()
{
    ALIB.imageLoad(alCore.sub, "title_c.bmp");

    back_r = ALIB.imageNew(200, 44);
    back_p = ALIB.imageNew(200, 44);
    ALIB.imageCopy(back_r, alCore.sub, 0, 0, 349, 88, 200, 44);
    ALIB.imageCopy(back_p, alCore.sub, 0, 0, 0, 407, 200, 44);

    stop_r = ALIB.imageNew(80, 44);
    stop_p = ALIB.imageNew(80, 44);
    ALIB.imageCopy(stop_r, alCore.sub, 0, 0, 549, 0, 80, 44);
    ALIB.imageCopy(stop_p, alCore.sub, 0, 0, 549, 44, 80, 44);

    play_r = ALIB.imageNew(64, 44);
    play_p = ALIB.imageNew(64, 44);
    ALIB.imageCopy(play_r, alCore.sub, 0, 0, 549, 88, 64, 44);
    ALIB.imageCopy(play_p, alCore.sub, 0, 0, 349, 132, 64, 44);
}

void
enter_music_mode()
{
    int first = True;

    if (first) {
	first = False;
	init_music_mode_widget();
    }

    push_stack(STAT_TTL_MUSIC);
    ALIB.imageLoad(alCore.vram, "music_bg.bmp");

    trap_area_clear();
    trap_area_add(118, 436, 200, 44);
    trap_area_add(358, 436, 80, 44);
    trap_area_add(458, 436, 64, 44);

    redraw_music_mode();
}

void
redraw_music_mode()
{
    ALIB.imageCopy(alCore.vram, back_r, 118, 436, 0, 0, 200, 44);
    ALIB.imageCopy(alCore.vram, stop_r, 358, 436, 0, 0, 80, 44);
    ALIB.imageCopy(alCore.vram, play_r, 458, 436, 0, 0, 64, 44);
    switch (trap_area_selected()) {
    case 0:
	ALIB.imageCopy(alCore.vram, back_p, 118, 436, 0, 0, 200, 44);
	break;
    case 1:
	ALIB.imageCopy(alCore.vram, stop_p, 358, 436, 0, 0, 80, 44);
	break;
    case 2:
	ALIB.imageCopy(alCore.vram, play_p, 458, 436, 0, 0, 64, 44);
	break;
    }
    // REQTBL.flushWindowArea(300, 200, 340, 280);
    REQTBL.flushWindow();
}
