/* 
 * Tenshi no Hashigo for X
 * Copyright (c) 2002 TF <tf@denpa.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: option.c,v 1.4 2002/03/03 15:37:00 tf Exp $
 */
#include <stdlib.h>
#include <string.h>
#include "aladder.h"

static void
opt_skip_jingle(int argc, char *argv[])
{
    CONFIG.skip_jingle = True;
}

static void
opt_skip_opening(int argc, char *argv[])
{
    CONFIG.skip_opening = True;
}

static void
opt_force_skip(int argc, char *argv[])
{
    CONFIG.force_skip = True;
}

static void
opt_fullscreen(int argc, char *argv[])
{
    CONFIG.window_size = CONFIG_FULLSCREEN;
}

static void
opt_test(int argc, char *argv[])
{
    int i;
    for (i = 0; i <= argc; i++)
	fprintf(stderr, "test[%d]: %s\n", i, argv[i]);
}

static struct {
    char *name;
    void (*func) (int argc, char *argv[]);
    int argc;
} options[] = {
    {
    "--skip-jingle", opt_skip_jingle, 0}, {
    "--skip-opening", opt_skip_opening, 0}, {
    "--force-skip", opt_force_skip, 0}, {
    "--fullscreen", opt_fullscreen, 0}, {
    "--test", opt_test, 2}
};

void
parse_argument(int argc, char *argv[], int *dargc_p, char **dargv_p[])
{
    int i, j;

    *dargc_p = 0;
    *dargv_p = (char **) calloc(argc, sizeof(char *));

    for (i = 0; i < argc; i++) {
	int found = False;
	for (j = 0; j < sizeof(options) / sizeof(options[0]); j++) {
	    if (!strcmp(argv[i], options[j].name)) {
		dprintf((stderr, "ץ: %s [%d]\n", argv[i],
			 options[j].argc));
		options[j].func(options[j].argc, argv + i);
		i += options[j].argc;
		found = True;
		break;
	    }
	}
	if (!found)
	    (*dargv_p)[(*dargc_p)++] = strdup(argv[i]);
    }
}
