/* 
 * Tenshi no Hashigo for X
 * Copyright (c) 2001, 2002 TF <tf@denpa.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by TF.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: sound.h,v 1.8 2002/03/03 15:37:00 tf Exp $
 */

#ifndef __INCLUDE_SOUND_H
#define __INCLUDE_SOUND_H

#include <sys/types.h>

/* 
 * б OS ɲäΤ:
 * 1. ɥǥХľá SoundInfo ¤ΤѰդƤ
 *    (sound-oss 򻲾)
 * 2. SDL Τ褦ݲؤѰդƤϡǤƤϤAPI
 *    ΤΤѰդ(music-oss 򻲾)
 */
typedef struct _SoundInfo {
    int control_fd;
    int pid;
    int playing;
    u_char *data;
    size_t length;

    /* ʬΤΥѥ᡼ */
    int play_byte;
    int play_wait;

    struct {
	int (*open) (struct _SoundInfo *sinfo);
	void (*close) (struct _SoundInfo *sinfo);
	int (*write) (struct _SoundInfo *sinfo, const u_char *data,
		      size_t len);
	void (*sync) (struct _SoundInfo *sinfo);
	void (*interrupt) (struct _SoundInfo *sinfo);
    } control;
} SoundInfo;

/* 
 * ƤϤAPI (ܼ)
 */
int BaseSoundOpen();
void BaseSoundClose();
void BaseSoundLoad(const char *name);
void BaseSoundPlay();
void BaseSoundStop();
int BaseSoundStatus();

#endif
